# Class TransformException

Object
Throwable
Exception
TransformException

All Implemented Interfaces:
  `Serializable`

Direct Known Subclasses:
  `GazetteerException, NoninvertibleTransformException, NotSpatioTemporalException`

public class TransformException extends Exception
Common superclass for a number of transformation-related exceptions. `TransformException` are thrown by `MathTransform` when a coordinate transformation cannot be inverted (`NoninvertibleTransformException`), when the derivative cannot be computed or when a coordinate cannot be transformed. It is also thrown when `CoordinateOperationFactory` fails to find a path between two coordinate reference systems.

Since:
  1.0
See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TransformException()`
  Constructs an exception with no detail message.
  `TransformException(String message)`
  Constructs an exception with the specified detail message.
  `TransformException(String message, Throwable cause)`
  Constructs an exception with the specified detail message and cause.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MathTransform`
  `getLastCompletedTransform()`
  Returns the last transform that either transformed successfully all coordinates, or filled the untransformable coordinates with NaN values.
  `void`
  `setLastCompletedTransform(MathTransform transform)`
  Sets the last transform that either transformed successfully all coordinates, or filled the untransformable coordinates with NaN values.

  ### Methods inherited from class Throwable

  `addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### TransformException

    public TransformException()
    Constructs an exception with no detail message.

  - ### TransformException

    public TransformException(String message)
    Constructs an exception with the specified detail message.
    Parameters:
      `message` - The detail message. The detail message is saved for later retrieval by the `Throwable​.getMessage()` method.

  - ### TransformException

    public TransformException(String message, Throwable cause)
    Constructs an exception with the specified detail message and cause.
    Parameters:
      `message` - The detail message. The detail message is saved for later retrieval by the `Throwable​.getMessage()` method.
      `cause` - The cause for this exception. The cause is saved for later retrieval by the `Throwable​.getCause()` method.

- ## Method Details

  - ### getLastCompletedTransform

    public MathTransform getLastCompletedTransform()
    Returns the last transform that either transformed successfully all coordinates, or filled the untransformable coordinates with NaN values. This information is useful in the context of concatenated transforms. May be `null` if unknown.
    Returns:
      The last reliable transform.
    Since:
      2.2

  - ### setLastCompletedTransform

    public void setLastCompletedTransform(MathTransform transform)
    Sets the last transform that either transformed successfully all coordinates, or filled the untransformable coordinates with NaN values.
    Parameters:
      `transform` - The last reliable transform.
    Since:
      2.2